unit PCSpk;

{* Program : PCSpk.Pas
   Purpose : TPCSpeaker Component

   Author        Version  Last Changed  Comments
   ------        -------  ------------  --------
   Song Weng Sam 1.00     Aug. 14, 96   Initial Release
   Song Weng Sam 1.01     Aug. 28, 96   Published the Delay Method
*}


interface

uses
   Classes, WinProcs, Forms;

type
   TPCSpeaker = class(TComponent)
   private
      { Private declarations }
      procedure NoSound;
      procedure Sound(Freq: Word);
   protected
      { Protected declarations }
   public
      { Public declarations }
      procedure Delay(MSecs: Integer);
      procedure Play(Freq: Word; MSecs: Integer);
      procedure Stop;
   published
      { Published declarations }
   end;

procedure Register;

implementation

procedure TPCSpeaker.NoSound;
begin
   Port[$61] := Port[$61] and $FC;
end;

procedure TPCSpeaker.Sound(Freq: Word);
var
   B : Byte;
begin
   if Freq > 18 then
      begin
         Freq := Word(1193181 div LongInt(Freq));

         B := Port[$61];

         if (B and 3) = 0 then
            begin
               Port[$61] := B or 3;
               Port[$43] := $B6;
            end;

         Port[$42] := Byte(Freq);
         Port[$42] := Byte(Freq shr 8);
      end;
end;

procedure TPCSpeaker.Delay(MSecs: Integer);
var
   FirstTickCount : LongInt;
begin
   FirstTickCount:=GetTickCount;
   repeat
      Application.ProcessMessages; {allowing access to other controls, etc.}
   until ((GetTickCount-FirstTickCount) >= LongInt(MSecs));
end;

procedure TPCSpeaker.Play(Freq: Word; MSecs: Integer);
begin
   Sound(Freq);
   Delay(MSecs);
   NoSound;
end;

procedure TPCSpeaker.Stop;
begin
   NoSound;
end;

procedure Register;
begin
   RegisterComponents('SongWS', [TPCSpeaker]);
end;

end.
